#ifndef _ANOD_CHEAT_LIBRARY_
#define _ANOD_CHEAT_LIBRARY_

#include <stdint.h>

#define INPUT(type) type
#define OUTPUT(type) type*

#define ACL_ENTRY_HOLE       1
#define ACL_ENTRY_KEY        2

#define ACHTLIB_SUCCESS      0
#define ACHTLIB_NOT_OPEN     1
#define ACHTLIB_NOT_FOUND    2
#define ACHTLIB_INVALID      3
#define ACHTLIB_NOMEM        4

typedef int              acl_error_t;
typedef const char*      acl_text_t;
typedef uint8_t          acl_boolean_t;
typedef uint32_t         acl_chtid_t;
typedef uint32_t         acl_chtpos_t;
typedef char             acl_region_t;
typedef uint32_t         acl_entryid_t;
typedef uint16_t         acl_elemlen_t;
typedef uint16_t         acl_index_t;
typedef uint32_t         acl_count_t;
typedef uint32_t         acl_armcode_t;

acl_error_t acl_open_lib( 
    INPUT(acl_text_t)     path_for_cht_file
);

acl_error_t acl_close_lib(
    void
);

acl_error_t acl_select_game(
    INPUT(acl_text_t)     code_for_game,
    INPUT(acl_boolean_t)  check_language_for_code,
    OUTPUT(acl_count_t)   cheat_set_count_for_game
);

acl_error_t acl_query_cheat_set( 
    INPUT(acl_index_t)    cheat_set_index,
    OUTPUT(acl_chtid_t)   cheat_set_id,
    OUTPUT(acl_region_t)  cheat_set_region
);

acl_error_t acl_select_cheat_set(
    INPUT(acl_chtid_t)    cheat_set_id
);

acl_error_t acl_select_entry(
    INPUT(acl_entryid_t)  entry_id,
    OUTPUT(acl_elemlen_t) entry_element_count
);

acl_error_t acl_entry_get_label(
    INPUT(acl_index_t)    index_of_entry_element,
    OUTPUT(acl_text_t)    label_of_entry_element
);

acl_error_t acl_entry_get_armcode(
    INPUT(acl_index_t)    index_of_entry_element,
    OUTPUT(acl_armcode_t) arm_code_of_entry_element
);

#endif//_ANOD_CHEAT_LIBRARY_